//
//	$Date: 2001/07/26 14:47:11 $
//	$Revision: 1.2 $
//
#if SDK_VERSION >= 35
#include <PalmOS.h>
#else
#include <Pilot.h>
#include "NewTypes.h"
#endif

#include "palmwiki.h"
#include "pwprefs.h"
#include "id.h"

static MemPtr GetObjectPtr(UInt16 objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return (FrmGetObjectPtr(frm, FrmGetObjectIndex (frm, objectID)));
}

static void
CopyFieldTextToBuf(FieldPtr field, Char *buf, UInt16 lim)
{
	Char *s;
	UInt16 len;
	s = FldGetTextPtr(field);
	len = FldGetTextLength(field);
	if(len > lim) len = lim;
	StrNCopy(buf,s,len);
	buf[len] = '\0';
}

Boolean PrefsHandleEvent(EventPtr event)
{
	Boolean handled = false;
	FieldPtr field;
	ControlPtr ctl;
	WikiPref pref;

	switch(event->eType){
	case ctlSelectEvent:
		switch (event->data.ctlSelect.controlID){
		case ID_BUTTON_OK:
			field = (FieldPtr)GetObjectPtr(ID_FIELD_LPAR);
			CopyFieldTextToBuf(field,pref.lpar,15);
			field = (FieldPtr)GetObjectPtr(ID_FIELD_RPAR);
			CopyFieldTextToBuf(field,pref.rpar,15);
			field = (FieldPtr)GetObjectPtr(ID_FIELD_MEMO);
			CopyFieldTextToBuf(field,pref.memo,4);
			field = (FieldPtr)GetObjectPtr(ID_FIELD_DATE);
			CopyFieldTextToBuf(field,pref.date,4);
			ctl = GetObjectPtr(ID_CHECKBOX_SINGLETAP);
			pref.singletap = (int)CtlGetValue(ctl);
			pref.linkstackindex = 0;
			pref.linkstackmax = 0;

			SetWikiPreferences(&pref);
//			PrefSetAppPreferences(PWCREATOR,0,1,&pref,sizeof(WikiPref),true);
			
			FrmGotoForm(9000); // Go back to HackMaster form
			handled = true;
			break;
		default:
			break;
		}
		break;
  	case frmOpenEvent:
        	FrmDrawForm(FrmGetActiveForm());

		GsiSetLocation(143,15);
		GsiEnable(true);

		GetWikiPreferences(&pref,true);

		field = (FieldPtr)GetObjectPtr(ID_FIELD_LPAR);
		FldInsert(field,pref.lpar,StrLen(pref.lpar));
		field = (FieldPtr)GetObjectPtr(ID_FIELD_RPAR);
		FldInsert(field,pref.rpar,StrLen(pref.rpar));
		field = (FieldPtr)GetObjectPtr(ID_FIELD_MEMO);
		FldInsert(field,pref.memo,StrLen(pref.memo));
		field = (FieldPtr)GetObjectPtr(ID_FIELD_DATE);
		FldInsert(field,pref.date,StrLen(pref.date));
		ctl = GetObjectPtr(ID_CHECKBOX_SINGLETAP);
		CtlSetValue(ctl, (short)pref.singletap);
		handled = true;
		break;
	default:
		handled = false;
		break;
	}
	return handled;
}

